varying mediump vec4 var_position;
varying mediump vec3 var_normal;
varying mediump vec2 var_texcoord0;
varying mediump vec4 var_light;

uniform lowp sampler2D tex0;
uniform lowp vec4 shaderTime;
uniform lowp vec4 resolution;
uniform lowp vec4 pixelation;

void main()
{
    vec2 res = vec2(1.0, 1.0);
    vec2 uv = var_texcoord0.xy * res.xy - 0.5;

    float dx = pixelation.x;
    float dy = pixelation.x * (resolution.x / resolution.y);
    uv.x = dx * floor(uv.x / dx);
    uv.y = dy * floor(uv.y / dy);

    float sTime = shaderTime.x * 0.5;

    float factA = 5.0;
    float factB = 7.5;

    float varA = (sin(uv.y * factB - sTime)) + sin(uv.x * factA - sTime * 2.0);
    float varB = (sin(uv.x * factB - sTime * 2.0)) + sin(uv.y * factA - sTime * 2.0);

    gl_FragColor = vec4(uv, uv.y, 1.0) + vec4(varA - 0.5, varA - 0.5, varA + 0.5, 1.0) * vec4(varB - 0.5, varB + 0.3, varB, 1.0) * 0.25;    
}

